
#ifndef __ERRORS_H__
#define __ERRORS_H__

#include <stdarg.h>

typedef enum {
	RETURN,
	ABORT
} ReturnType;

// error codes
typedef enum {
    // general
	MISSING_PARAMETER,
	INVALID_ANSWER,
	INVALID_RELATIONAL_INT,
	INVALID_RELATIONAL_FLT,
	INVALID_VALUE_INT,
	INVALID_VALUE_FLT,
	NOT_EVEN,
	IGNORE,
	DENOM_NEAR_ZERO,
	SINGULAR_MATRIX,
	NO_LIFTING_MATRIX,
	NO_FILTER_VECTOR,
	FATAL_ERROR,
	// insufficient memory error
	VECTOR_CLASS,
	MATRIX_CLASS,
	IMAGE_CLASS,
	//file
	NO_FILE,
	NO_DIR,
	READ_ERROR,
	WRITE_ERROR,
	INVALID_FILE_FORMAT,
	NO_READABLE_FORMAT,
	NO_FORMAT,
    CUSTOM
} ErrorCode;

extern void Error ( const char *pFunctionName, const ErrorCode eErrorCode,
                    const ReturnType eReturnType, ... );

#endif // __ERRORS_H__ 
