
#ifndef __LIFTING_H__
#define __LIFTING_H__

#include <global.h>

extern void 
LUDecompose ( Matrix __a, int __n, int *__indx, float *__d );

extern void 
LUBacksubstitute ( Matrix __a, int __n, int *__indx, Vector __b );

extern bool
InitMomentsMatrix ( const int __nTilde, const int __cols, const int __rows,
                    const bool __print_coeff );

extern void
FreeMomentsMatrix ( const int __cols, const int __rows, const int __nTilde );

extern void
GetLifting ( Vector __lifting, const Vector __filter, const int __step,
             const int __N, const int __nTilde, const int __L,
             const bool __XYdir, const bool __type );

extern float 
Neville ( const float *__x, const float *__f,
                     const int __n, const float __xx );

extern Vector 
GetFilter ( const int __N );

#endif // __LIFTING_H__ 



